// This software is supplied under the terms of a license agreement or
// nondisclosure agreement with B-Alive GmbH and may not 
// be copied or disclosed except in accordance with the terms of that 
// agreement.
//
//      Copyright (c) 2004-2008 B-Alive GmbH.
//      All Rights Reserved.
//
// B-Alive GmbH
// http://www.b-alive.de
//
// author: mad
// date: 29.07.2009

#ifndef GLOBALFX_HEADER
#define GLOBALFX_HEADER

// ------------
#include "GlobalShaderDefines.h"

// handled by application now
//#define MIN_SHADER_VERSION

// ---------------------
#if (VERTEXSHADER_VERSION >= 30)
#   define SUPPORTS_SHADERMODEL_3_0
#elif (VERTEXSHADER_VERSION >= 20)
#   define SUPPORTS_SHADERMODEL_2_0
#elif (VERTEXSHADER_VERSION >= 14)
#   define SUPPORTS_SHADERMODEL_1_4
#elif (VERTEXSHADER_VERSION >= 13)
#   define SUPPORTS_SHADERMODEL_1_3
#else
#   define SUPPORTS_SHADERMODEL_1_1
#endif // ...

// ---------------------
// -> die Shader, die ein Mindestlevel erfordern
#if (VERTEXSHADER_VERSION > 11) && !defined(MIN_SHADER_VERSION)
    #define SHAD_VS_MINVER_1_1  SHAD_VS_VERSION
#else
    #define SHAD_VS_MINVER_1_1  vs_1_1
#endif

#if (VERTEXSHADER_VERSION > 20) && !defined(MIN_SHADER_VERSION)
    #define SHAD_VS_MINVER_2_0  SHAD_VS_VERSION
#else
    #define SHAD_VS_MINVER_2_0  vs_2_0
#endif

#define SHAD_VS_MINVER_3_0      vs_3_0

// ---------------------
#if (PIXELSHADER_VERSION > 11) && !defined(MIN_SHADER_VERSION)
    #define SHAD_PS_MINVER_1_1  SHAD_PS_VERSION
#else
    #define SHAD_PS_MINVER_1_1  ps_1_1
#endif

#if (PIXELSHADER_VERSION > 14) && !defined(MIN_SHADER_VERSION)
    #define SHAD_PS_MINVER_1_4  SHAD_PS_VERSION
#else
    #define SHAD_PS_MINVER_1_4  ps_1_4
#endif

#if (PIXELSHADER_VERSION > 20) && !defined(MIN_SHADER_VERSION)
    #define SHAD_PS_MINVER_2_0  SHAD_PS_VERSION
#else
    #define SHAD_PS_MINVER_2_0  ps_2_0
#endif

#if (PIXELSHADER_VERSION > 21) && !defined(MIN_SHADER_VERSION)
    #define SHAD_PS_MINVER_2_0A SHAD_PS_VERSION
#else
    #define SHAD_PS_MINVER_2_0A ps_2_a
#endif

#define SHAD_PS_MINVER_3_0      ps_3_0

#endif