// BALIVE LIMITED PROPRIETARY INFORMATION //
// This software is supplied under the terms of a license agreement or
// nondisclosure agreement with B-Alive GmbH and may not 
// be copied or disclosed except in accordance with the terms of that 
// agreement.
//
//      Copyright (c) 2004-2007 B-Alive GmbH.
//      All Rights Reserved.
//
// B-Alive GmbH
// http://www.b-alive.de
//
// author: ank
// date: 18.01.2006

#include <ShaderFragments.hlsl>

// ================================================================================================
const float4    LIGHT_COLOR         : GLOBAL;

// ================================================================================================
sampler2D Sampler = sampler_state
{
	Texture = (BaseMap);
	AddressU = Wrap;
	AddressV = Wrap;
    MinFilter = (MIN_FILTERTYPE);
	MagFilter = (MAG_FILTERTYPE);
  	MipFilter = (MIP_FILTERTYPE);
  	MaxAnisotropy = (MAX_ANISOTROPY);
};

// ================================================================================================
VS_PosColUV0 VS_Panorama(VS_PosColUV0 p_vsIn)
{
    VS_PosColUV0 o;
    o.vPosition = mul(p_vsIn.vPosition, matWorldViewProjection);
    o.vColor = LIGHT_COLOR;
    o.vTex = p_vsIn.vTex;
    return o;
};

// ================================================================================================
float4 PS_Panorama(PS_ColUV0 p_psIn) : COLOR
{	
	return tex2D(Sampler, p_psIn.vTex) * p_psIn.vColor;
}

// ================================================================================================
technique Panorama
{
	pass p0
	{
		FillMode            = <GROUND_FILL_MODE>;
		ShadeMode           = Gouraud;
	    CullMode            = CW;
	    ZEnable             = true;
	    ZWriteEnable        = true;
	    AlphaTestEnable     = true;
	    AlphaRef            = 0;
	    AlphaFunc           = greater;
	    AlphaBlendEnable    = true;
	    SrcBlend            = SrcAlpha;
	    DestBlend           = InvSrcAlpha;
	    Lighting            = false;
	    		
		VertexShader = compile  SHAD_VS_MINVER_1_1  VS_Panorama();
		PixelShader  = compile  SHAD_PS_MINVER_1_1  PS_Panorama();
	}
}
