// BALIVE LIMITED PROPRIETARY INFORMATION //
// This software is supplied under the terms of a license agreement or
// nondisclosure agreement with B-Alive GmbH and may not 
// be copied or disclosed except in accordance with the terms of that 
// agreement.
//
//      Copyright (c) 2004-2008 B-Alive GmbH.
//      All Rights Reserved.
//
// B-Alive GmbH
// http://www.b-alive.de
//
// author: ank
// date: 19.01.2006

#include <ShaderFragments.hlsl>

// ================================================================================================
sampler2D SamplerShadow = sampler_state
{
    Texture = (BaseMap);
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Point;
    MaxAnisotropy = 1;
};

// ================================================================================================
VS_PosUV0 VS_SimpleTransform(VS_PosUV0 p_vsIn)
{
    VS_PosUV0 o;
    o.vPosition = mul(p_vsIn.vPosition, matWorldViewProjection);
    o.vTex = p_vsIn.vTex;
    return o;
}

// ================================================================================================
float4 PS_ModulateTexWithShadowColor(float2 p_vTex : TEXCOORD0) : COLOR
{
    float4 col = tex2D(SamplerShadow, p_vTex);
    col.a = col.r;
	return col * MaterialEmissive;
}

// ================================================================================================
float4 PS_ModulatePlantTexWithShadowColor(float2 p_vTex : TEXCOORD0) : COLOR
{
    float4 col = tex2D(SamplerShadow, p_vTex);
    col = float4(1,1,1,1) - col;    // invertieren (Pflanzenschatten sind grau auf wei)
    col.a = col.r;
	return col * MaterialEmissive;
}

// ================================================================================================
technique Shadow
{
	pass p0
	{	    
	    CullMode            = cw;
	    ShadeMode           = flat;
		ZEnable             = true;
		ZWriteEnable        = false;
		AlphaBlendEnable	= true;
		AlphaTestEnable	    = true;
		AlphaRef            = 0;
		AlphaFunc           = greater;
		SrcBlend            = SrcAlpha;
        DestBlend           = InvSrcAlpha;
	    Lighting			= false;
		
		VertexShader = compile  SHAD_VS_MINVER_1_1  VS_SimpleTransform();
		PixelShader  = compile  SHAD_PS_MINVER_1_1  PS_ModulateTexWithShadowColor();
	}
}

// ================================================================================================
technique ShadowPlant
{
	pass p0
	{
		CullMode            = cw;
	    ShadeMode           = flat;
		ZEnable             = true;
		ZWriteEnable        = false;
		AlphaBlendEnable	= true;
		AlphaTestEnable	    = true;
		AlphaRef            = 0;
		AlphaFunc           = greater;
		SrcBlend            = SrcAlpha;
        DestBlend           = InvSrcAlpha;
	    Lighting			= false;
		
		VertexShader = compile  SHAD_VS_MINVER_1_1  VS_SimpleTransform();
		PixelShader  = compile  SHAD_PS_MINVER_1_1  PS_ModulatePlantTexWithShadowColor();
	}
}
